(() => {
    const findUpstream = () => {
        const search = new URLSearchParams(location.search);
        search.set("render", "false");
        const url = new URL(location.origin);
        url.pathname = location.pathname;
        url.search = search.toString();
        return url.href;
    }

    const upstream = findUpstream();
    const xhr = new XMLHttpRequest();
    xhr.open("HEAD", upstream, true);
    xhr.send();

    let count = 2;
    const handleCount = () => {
        if(--count === 0) {
            handle();
        }
    }

    const handle = () => {
        const [body] = document.getElementsByTagName("body");
        const video = document.createElement("video");
        video.className = "video-js vjs-big-play-centered";
        body.appendChild(video);
        const ctype = xhr.getResponseHeader("Content-Type");
        console.log(ctype);
        const options = {};
        options.controls = true;
        options.liveui = true;
        options.responsive = true;
        options.fill = true;
        options.techOrder = ["chromecast", "html5"];
        options.plugins = {};
        options.plugins.chromecast = {};
        const player = videojs(video, options);
        const source = {};
        source.type = ctype;
        source.src = upstream;
        player.src(source);
        const Button = videojs.getComponent("Button");
        const cbutton = {};
        cbutton.clickHandler = (ev) => {
            player.trigger("chromecastRequested");
        }
        const button = new Button(player, cbutton);
        button.addClass("fab");
        button.addClass("fa-chromecast");
        button.addClass("vjs-control");
        button.addClass("vjs-button");
        button.addClass("vjs-big-chromecast");

        player.addChild(button);
        player.one("play", () => {
            player.removeChild(button);
        });
        player.on("chromecastConnected", () => {
            if(player.volume() > 0.3) {
                player.volume(0.3);
            }
        });
    }
    document.addEventListener("DOMContentLoaded", handleCount);
    xhr.addEventListener("load", handleCount);
})();
